/*****************************************************************************
*   Copyright (c) 1997-1998 by Joseph Parrello. All Rights Reserved.         *
*   Site   : http://space.tin.it/computer/giparrel                           *
*   E-Mail : joparrel@tin.it, giusparr@tin.it, giparre@tin.it                *
*                                                                            *
*   Revision:   2.1  (July 31, 1998).                                        *
*                                                                            *
*   Definition of JPDialog class.                                            *
*                                                                            *
*   Read JPDIALOG.TXT for use and license.                                   *
*                                                                            *
*   Only for OWL 5.02 and 5.01 users.                                        *
*   OWL and ObjectWindows are trademarks of Borland International.           *
*                                                                            *
*   THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF       *
*   ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO      *
*   THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A           *
*   PARTICULAR PURPOSE.                                                      *
*****************************************************************************/
#if !defined(jpdialog_h)
#define jpdialog_h

#if !defined(OWL_DIALOG_H)
#include <owl/dialog.h>
#endif
#include "jptooltp.h"

//{{TDialog = JPDialog}}
class JPDialog : public TDialog {
  public:
    JPDialog(TWindow* parent,
             TResId resId,
             TModule* module = 0,
             JPTooltipSupport* mytooltip = NULL,
             bool FullTooltipSupport = false,
             bool AlwaysForceRectAssociate = false,
             bool ForceRectAssociateIfDisabled = false,
             bool EnableStatusbarMessages = false);
    virtual ~JPDialog();

//{{JPDialogVIRTUAL_BEGIN}}
  public:
    virtual bool  EvInitDialog(HWND hWndFocus);
    virtual bool  IdleAction(long idleCount);
    virtual void  SetStatusbarMessage(int Id);
    HWND    FindChildFromPoint(HWND hwnd, POINT Point);
//{{JPDialogVIRTUAL_END}}

//{{JPDialogRSP_TBL_BEGIN}}
  protected:
    JPTooltipSupport*  GlobalTooltip;
    bool               forceRectAssociate;
    bool               forceDisabledAssociate;
    bool               isFullSupport;
    bool               sbarMessage;
    HWND               currentHwnd;
    TDecoratedFrame*   decFrame;
//{{JPDialogRSP_TBL_END}}
};    //{{JPDialog}}

#endif

