/*******************************************************************************
*  Copyright (c) 1997, 1998 by Joseph Parrello. All Rights Reserved.           *
*  Site   : http://space.tin.it/computer/giparrel                              *
*  E-Mail : joparrel@tin.it, giusparr@tin.it, giparre@tin.it                   *
*                                                                              *
*  Revision:   2.0  (July 31, 1998).                                           *
*                                                                              *
*  Definition of JPPropertySheet and JPPropertyPage classes.                   *
*                                                                              *
*  Read JPPRPAGE.TXT for use and license.                                      *
*                                                                              *
*  Only for OWL 5.02 and 5.01 users.                                           *
*  OWL and ObjectWindows are trademarks of Borland International.              *
*                                                                              *
*  THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF          *
*  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO         *
*  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A              *
*  PARTICULAR PURPOSE.                                                         *
*******************************************************************************/
#if !defined(jpprpage_h)
#define jpprpage_h

#if !defined(OWL_PROPSHT_H)
#include <owl/propsht.h>
#endif
#include "jptooltp.h"

class JPPropertySheet : public TPropertySheet {
  public:
    JPPropertySheet(TWindow* parent,
                    const char far* title,
                    uint startPage = 0,
                    bool isWizard = false,
                    uint32 flags = PSH_DEFAULT,
                    TModule* module = 0,
                    JPTooltipSupport* mytooltip = NULL,
                    bool FullTooltipSupport = false,
                    bool AlwaysForceRectAssociate = false,
                    bool ForceRectAssociateIfDisabled = false,
                    bool EnableStatusbarMessages = false);
    virtual ~JPPropertySheet();

//{{JPPropertySheetVIRTUAL_BEGIN}}
  public:
    virtual void        SetupWindow();
    virtual void        CleanupWindow();
    JPTooltipSupport*   GetGlobalTooltip();
    void                SetStatusbarMessage(int Id);
    HWND                FindChildFromPoint(HWND hWndParent, POINT Point);
    TDecoratedFrame*    GetDecoratedFrame();

  protected:
    JPTooltipSupport* GlobalSheetTooltip;
    bool              forceRectAssociate;
    bool              forceDisabledAssociate;
    bool              isFullSupport;
    bool              sbarMessage;
    HWND              currentHwnd;
    TDecoratedFrame*  decFrame;

  protected:
    bool          EvSetCursor(HWND hWndCursor, uint hitTest, uint mouseMsg);

  DECLARE_RESPONSE_TABLE(JPPropertySheet);
  DECLARE_CASTABLE;
//{{JPPropertySheetVIRTUAL_END}}
};    //{{JPPropertySheet}}

//{{TPropertyPage = JPPropertyPage}}
class JPPropertyPage : public TPropertyPage {
  public:
    JPPropertyPage(JPPropertySheet* parent,
                   TResId resId,
                   const char far* title = 0,
                   TResId iconRes = 0,
                   TModule* module = 0,
                   bool FullTooltipSupport = false,
                   bool AlwaysForceRectAssociate = false,
                   bool ForceRectAssociateIfDisabled = false,
                   bool EnableStatusbarMessages = false);
    virtual ~JPPropertyPage();

//{{JPPropertyPageVIRTUAL_BEGIN}}
  public:
    virtual void  SetupWindow();
    virtual void  CleanupWindow();
    virtual void  SetGlobalTooltip(JPTooltipSupport* mytooltip);

  protected:
    bool          EvSetCursor(HWND hWndCursor, uint hitTest, uint mouseMsg);
//{{JPPropertyPageVIRTUAL_END}}

//{{JPPropertyPageRSP_TBL_BEGIN}}
  protected:
    JPTooltipSupport*  GlobalTooltip;
    JPPropertySheet*   psheet;
    bool               forceRectAssociate;
    bool               forceDisabledAssociate;
    bool               isFullSupport;
    bool               sbarMessage;
    HWND               currentHwnd;
    TDecoratedFrame*   decFrame;

  DECLARE_RESPONSE_TABLE(JPPropertyPage);
  DECLARE_CASTABLE;
//{{JPPropertyPageRSP_TBL_END}}
};    //{{JPPropertyPage}}



#endif

