/*******************************************************************************
*  Copyright (c) 1997, 1998 by Joseph Parrello. All Rights Reserved.           *
*  Site   : http://space.tin.it/computer/giparrel                              *
*  E-Mail : joparrel@tin.it, giusparr@tin.it, giparre@tin.it                   *
*                                                                              *
*  Revision:   2.0  (July 31, 1998).                                           *
*                                                                              *
*  Definition of JPTooltipSupport class.                                       *
*                                                                              *
*  Read JPTOOLTP.TXT for use and license.                                      *
*                                                                              *
*  Only for OWL 5.02 and 5.01 users.                                           *
*  OWL and ObjectWindows are trademarks of Borland International.              *
*                                                                              *
*  THIS CLASS AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF          *
*  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO         *
*  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A              *
*  PARTICULAR PURPOSE.                                                         *
*******************************************************************************/
#if !defined(jptooltp_h)
#define jptooltp_h

#if !defined(__TCHAR_H)
#include <tchar.h>
#endif
#if !defined(OWL_TOOLTIP_H)
#include <owl/tooltip.h>
#endif
#if !defined(OWL_MODULE_H)
#include <owl/module.h>
#endif

//{{TTooltip = JPTooltipSupport}}
class JPTooltipSupport {
  public:
    JPTooltipSupport(TWindow* parent);
    virtual ~JPTooltipSupport();

  public:
  void      AssociateTooltips(HWND hwnd, bool IsAssociate = false,
                              bool FullTooltipSupport = false,
                              bool AlwaysForceRectAssociate = false,
                              bool ForceRectAssociateIfDisabled = false);

  private:
  void      EnableHookProc(bool Enable);
  int       RetrieveTooltipString(_TCHAR* szBuf, uint menuItemId);
  TWindow*  parentwindow;
};    //{{JPTooltipSupport}}


#endif

